#include <bits/stdc++.h>

const int MAXN = 1e5;

std::vector<int> readAndParse() {
	std::string s;
	std::cin >> s;
	s += '.';
	std::string current;
	std::vector<int> answer;
	for (int i = 0; i < (int)s.size(); i++) {
		if (s[i] == '.') {
			answer.push_back(std::stoi(current));
			current = "";
		} else {
			current += s[i];
		}
	}
	return answer;
}

unsigned long long encode(const std::vector<int> &a) {
	unsigned long long result = 0;
	for (int i = 0; i < (int)a.size(); i++) {
		result = result * 256 + a[i];
	}
	return result;
}

int main() {
	int n, x;
	std::cin >> n >> x;
	assert(x == 1 && n <= 256);
	std::vector<unsigned long long> addresses(n);
	for (int i = 0; i < n; i++) {
		addresses[i] = encode(readAndParse());
	}
	std::vector<int> a = readAndParse();
	std::vector<int> b = readAndParse();
	unsigned long long ea = encode(a);
	unsigned long long eb = encode(b);
	unsigned long long diff = eb - ea + 1;
	if (diff <= 3 * MAXN) {
		std::vector<unsigned long long> between;
		for (int i = 0; i < n; i++) {
			if (ea <= addresses[i] && addresses[i] <= eb) {
				between.push_back(addresses[i]);
			}
		}
		between.push_back(ea - 1);
		between.push_back(eb + 1);
		std::sort(between.begin(), between.end());
		bool found = false;
		for (int i = 0; i + 1 < (int)between.size(); i++) {
			if (between[i + 1] - between[i] >= 3) {
				found = true;
			}
		}
		if (found)
			std::cout << diff - (unsigned long long)between.size() << '\n';
		else
			std::cout << "-1\n";
	} else {
		int between = 0;
		for (int i = 0; i < n; i++) {
			if (ea <= addresses[i] && addresses[i] <= eb) between++;
		}
		std::cout << diff - between - 2 << '\n';
	}
	return 0;
}