#include "testlib.h"
#include <vector>
#include <set>

using namespace std;

int MAXNS[] = {7, 100, 1000, 100, 1000, 10, 100, 1000};
int MAXKS[] = {2,   1,    1,   2,    2, 10, 100, 1000};

const int MAXC = 1000000000;

vector<vector<int>> gr;
vector<bool> used;

void dfs(int u) {
    used[u] = true;
    for (int v : gr[u]) {
        if (!used[v]) {
            dfs(v);
        }
    }
}

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);

    int grp;
    if (validator.group().size()) {
        grp = validator.group()[0] - '0';
    } else {
        grp = 7;
    }

    int n = inf.readInt(1, MAXNS[grp], "n");
    inf.readSpace();
    int k = inf.readInt(1, min(n, MAXKS[grp]), "k");
    inf.readEoln();

    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        a[i] = inf.readInt(-MAXC, MAXC, format("a[%d]", i));
        if (i != n - 1) {
            inf.readSpace();
        }
    }
    inf.readEoln();

    gr.resize(n);
    set<pair<int, int>> was;
    for (int i = 0; i < n - 1; i++) {
        int u = inf.readInt(1, n, format("u[%d]", i));
        inf.readSpace();
        int v = inf.readInt(1, n, format("v[%d]", i));
        inf.readEoln();

        ensuref(u != v, "edge %d is a loop", i);

        if (u > v) {
            swap(u, v);
        }

        ensuref(!was.count({u, v}), "duplicate edge (%d, %d)", u, v);
        was.emplace(u, v);

        u--;
        v--;

        gr[u].push_back(v);
        gr[v].push_back(u);
    }

    used.resize(n);
    dfs(0);

    for (int i = 0; i < n; i++) {
        ensuref(used[i], "graph is not connected");
    }

    inf.readEof();

    return 0;
}
